package com.example.bookingapp_austinblanke;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

import androidx.annotation.Nullable;


public class DatabaseConnector extends SQLiteOpenHelper {

    private static final String DB_NAME = "Registration.db";

    private static final int DB_VERSION = 1;

    private static final String TABLE_USERS = "Users";

    private static final String COLUMN_UID = "uid";

    private static final String COLUMN_USERNAME = "username";

    private static final String COLUMN_PASSWORD = "password";

    public DatabaseConnector(Context context, SQLiteDatabase.CursorFactory factory)
    {
        super(context, DB_NAME, factory, DB_VERSION);
    }

    @Override
    public void onCreate(SQLiteDatabase db) {

        String CREATE_table = "CREATE TABLE "+TABLE_USERS+"("+
                COLUMN_UID+" INTEGER PRIMARY KEY, " +
                COLUMN_USERNAME + " TEXT, " +
                COLUMN_PASSWORD + " TEXT)";
        db.execSQL(CREATE_table);
    }

    public void addNewUser(String username, String password)
    {
        ContentValues values = new ContentValues();
        values.put(COLUMN_USERNAME, username);
        values.put(COLUMN_PASSWORD, password);

        SQLiteDatabase db = this.getWritableDatabase();
        db.insert(TABLE_USERS, null, values);
        db.close();
    }

    @Override
    public void onUpgrade(SQLiteDatabase sqLiteDatabase, int i, int i1) {

    }

    public boolean usernameRepeat(String username){
        boolean result = false;
        String query = "SELECT * FROM " + TABLE_USERS + " WHERE " + COLUMN_USERNAME + " = \"" + username +"\"";
        SQLiteDatabase db = this.getWritableDatabase();
        Cursor cursor = db.rawQuery(query, null);

        if(cursor.getCount() == 0){
            result = false;
        }
        else result = true;


        cursor.close();
        db.close();

        return result;
    }

    public boolean login(String username, String password) {
        String query = "SELECT * FROM " + TABLE_USERS + " WHERE " + COLUMN_USERNAME + " = \"" + username +"\"";
        SQLiteDatabase db = this.getWritableDatabase();
        Cursor cursor = db.rawQuery(query, null);

        boolean result = false;

        if (cursor.moveToFirst()){
            if (cursor.getString(2).equals(password))
                result = true;
            else
                result = false;
        }

        cursor.close();
        db.close();

        return result;
    }
}
